;################################################################################
;#										#
;# libmio - multi i/o for ATMega 8 	version 0.01				#
;# copyright (c) 2005-2008 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;# * PAL/NTSC RGB videodisplay with up to 24x15 chars and 8 colors		#
;# * 1 channel sound can play notes and noise					#
;# * ps2-keyboard interface							#
;# * pseudorandom generator							#
;#										#
;# This library is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU Lesser General Public			#
;# License as published by the Free Software Foundation; either			#
;# version 2 of the License, or (at your option) any later version.		#
;#										#
;# This library is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the GNU		#
;# Lesser General Public License for more details.				#
;#										#
;# You should have received a copy of the GNU Lesser General Public		#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################

.macro libmio_vint
    rjmp	libmio_isr
.endm

.macro libmio_init
    rcall	libmio_init
.endm

.macro libmio_outchar
    call	libmio_char
.endm

.macro libmio_outspace
    rcall	libmio_space
.endm

.macro libmio_waitkey
    .set	use_libmio_waitkey = 1
    .set	libmio_ps2key = 1
    call	libmio_waitkey
.endm

.macro libmio_nokey
    .set	use_libmio_waitnokey = 1
    .set	libmio_ps2key = 1
    call	libmio_wnokey
.endm

.macro libmio_cursor
    .set	use_libmio_cursor = 1
    .set	libmio_ps2key = 1
    call	libmio_cursor
.endm

.macro libmio_freecur
    .set	use_libmio_cursor = 1
    .set	libmio_ps2key = 1
    rcall	libmio_cur1
.endm

.macro libmio_outdez
    .set	use_libmio_outd = 1
    rcall	libmio_outd
.endm

.macro libmio_clrscr
    call	libmio_clr
.endm

.macro libmio_fillchar
    rcall	libmio_fill
.endm

.macro libmio_ramtext
    .set	use_libmio_oram = 1
    rcall	libmio_oram
.endm

.macro libmio_input
    .set	use_libmio_input = 1
    call	libmio_inp
.endm

.macro libmio_romtext
    .set	use_libmio_orom = 1
    rcall	libmio_orom
.endm

.macro libmio_thistext
    .set	use_libmio_othis = 1
    .set	use_libmio_gotoxy = 1
    call	libmio_othis
.endm

.macro libmio_thisinvtext
    .set	use_libmio_othis = 1
    .set	use_libmio_gotoxy = 1
    call	libmio_othisi
.endm

.macro libmio_mtext
    .set	use_libmio_mtext = 1
    rcall	libmio_mtext
.endm

.macro libmio_newline
    .set	use_libmio_newline = 1
    rcall	libmio_newline
.endm

.macro libmio_gotoxy
    .set	use_libmio_gotoxy = 1
    call	libmio_gxy
.endm

.macro libmio_plot
    .set	use_libmio_plot = 1
    call	libmio_plot
.endm

.macro libmio_box
    .set	use_libmio_plot = 1
    .set	use_libmio_box = 1
    call	libmio_box
.endm

.macro libmio_cbox
    .set	use_libmio_cbox = 1
    rcall	libmio_cbox
.endm

.macro libmio_ibox
    .set	use_libmio_ibox = 1
    rcall	libmio_ibox
.endm

.macro libmio_wbox
    .set	use_libmio_wbox = 1
    rcall	libmio_wbox
.endm

.macro libmio_whbox
    .set	use_libmio_wbox = 1
    .set	use_libmio_whbox = 1
    rcall	libmio_whbox
.endm

.macro libmio_wh2box
    .set	use_libmio_wbox = 1
    .set	use_libmio_whbox = 1
    rcall	libmio_wh2box
.endm

.macro libmio_fbox
    .set	use_libmio_plot = 1
    .set	use_libmio_fbox = 1
    call	libmio_fbox
.endm

.macro libmio_draw
    .set	use_libmio_plot = 1
    .set	use_libmio_draw = 1
    rcall	libmio_draw
.endm

.macro libmio_sync
    .set	use_libmio_sync = 1
    call	libmio_sync
.endm

.macro libmio_wms
    .set	use_libmio_wms = 1
    call	libmio_wms
.endm

.macro libmio_note
    .set	use_libmio_note = 1
    rcall	libmio_note
.endm

.macro libmio_calc
    call	libmio_calc
.endm

.macro libmio_ecalc
    rcall	libmio_ecalc
.endm

.macro libmio_setcolor
    rcall	libmio_setcol
.endm

.macro libmio_setnormal
    call	libmio_setnorm
.endm

.macro libmio_setinvers
    rcall	libmio_setinv
.endm

.macro libmio_calc
    call	libmio_calc
.endm

.macro libmio_vcur
    .set	use_libmio_vcur = 1
    rcall	libmio_vcur
.endm

.macro libmio_random
    .set	use_libmio_psrg = 1
    rcall	libmio_psrg
.endm

.macro libmio_scroll
    rcall	libmio_scrl
.endm

.macro libmio_getser
    rcall	libmio_gser
.endm

.macro libmio_putser
    call	libmio_pser
.endm

.macro libmio_screenshot
    call	libmio_scrs
.endm


.equ	libmio_rampos_l	= 0
.equ	libmio_rampos_h = 1
.equ	libmio_vflags	= 2
.equ	libmio_frames	= 3
.equ	libmio_cline	= 4
.equ	libmio_kbdshift	= 5
.equ 	libmio_kbdstate	= 6
.equ	libmio_scancode	= 7
.equ	libmio_keycode	= 8
.equ	libmio_lastkey	= 9

.equ	libmio_rand1	= 10
.equ	libmio_rand2	= 11
.equ	libmio_rand3	= 12
.equ	libmio_rand4	= 13
.equ	libmio_color	= 14
.equ	libmio_kflags	= 15

.equ	libmio_dds_l	= 16
.equ	libmio_dds_h	= 17
.equ	libmio_envval	= 18
.equ	libmio_tone	= 19
.equ	libmio_pwm	= 20
.equ	libmio_tincnt	= 21
.equ	libmio_tintmp	= 22
.equ	libmio_serout	= 23
.equ	libmio_tcnt	= 24
.equ	libmio_tdat	= 25
.equ	libmio_cflag	= 26
.equ	libmio_rcnt	= 27
.equ	libmio_rdat	= 28
.equ	libmio_serin	= 29
.equ	libmio_fastmode = 30
;################################################################################
;#										#
;# libi2c - I2C library for ATMega controllers V0.10				#
;# copyright (c) 2007 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;# This library is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU Lesser General Public			#
;# License as published by the Free Software Foundation; either			#
;# version 2 of the License, or (at your option) any later version.		#
;#										#
;# This library is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the GNU		#
;# Lesser General Public License for more details.				#
;#										#
;# You should have received a copy of the GNU Lesser General Public		#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################

.macro libi2c_init
    call	libi2c_initl
.endm

.macro libi2c_read
    .set	use_libi2c_read = 1
    call	libi2c_read
.endm

.macro libi2c_start
    rcall	libi2c_start
.endm

.macro libi2c_stop
    call	libi2c_stop
.endm

.macro libi2c_rbyte
    rcall	libi2c_rbyte
.endm

.macro libi2c_rbyten
    rcall	libi2c_rbyten
.endm

.macro libi2c_wbyte
    rcall	libi2c_wbyte
.endm


.macro libi2c_write
    .set	use_libi2c_write = 1
    call	libi2c_write
.endm

;################################################################################
;#										#
;# libeep - EEPRO R/W library for AVR controllers V0.10				#
;# copyright (c) 2007 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;# This library is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU Lesser General Public			#
;# License as published by the Free Software Foundation; either			#
;# version 2 of the License, or (at your option) any later version.		#
;#										#
;# This library is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the GNU		#
;# Lesser General Public License for more details.				#
;#										#
;# You should have received a copy of the GNU Lesser General Public		#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################

.macro libeep_read
    rcall	libeep_read
.endm

.macro libeep_write
    rcall	libeep_write
.endm

